﻿/**
 * @author kubaszek
 * GraphPoly - graph for PN
 */
class graphPoly extends graph0 {

public var mcPoly :MovieClip = null;

public var mcPoly0 :MovieClip = null;
//do copy of mcPoly, when mouse click

public var mcPolyLim :MovieClip = null;
//Draw on grid - limes by small h and big pN.max_N
public static var bPolyLimDrawn :Boolean = false; //static because in onXXXX

public var nDepthPolyLim :Number = 0;
public var nDepthPoly0 :Number = 0;
public var nDepthPoly :Number = 0;

public var nPolyColor :Number = 0;
public var nPolyPtColor :Number = 0;
public var nPtSize :Number = 5;
public var nLnSize :Number = 1;
public var nPolyColor0 :Number = 0x0402FC;
public var nPolyPtColor0 :Number = 0x0000FF;
public var nPtSize0 :Number = 5;
public var nLnSize0 :Number = 1;

public var nPolyColorLim :Number = 0xAaAaAa;
public var nPolyPtColorLim :Number = 0xAaAaAa;
public var nPtSizeLim :Number = 1;
public var nLnSizeLim :Number = 2;

//obrazki z objaśnieniami
//public var mcInfo:MovieClip;
//Teskty z objasnieniami
private var tfInfo:TextField = null;
public var nDepthInfo :Number = 0;
	
//zmienne globalne, bo nie umiem inaczej się odwołać w onChanged()
//(czyli inna instancja powinna mieć pola zablokowane do edycji...
public static var nX_min :Number = 0;
public static var nX_max :Number = 10;
public static var nY_min :Number = -300;
public static var nY_max :Number = 300;

public static var alphaInf = 16;
public static var grphType :Number = 9;
public static var GRPH_TYPE_NUM :Number = 10;
public static var HDR_GR_TYPE_STR :Array = new Array( //html
//0:200sin(2t)
"<fun>{<v>f</v>(<v>t</v>)} = {200 ∙ sin( 2∙<v>t</v> )} </fun>",
//1:200  / (p²+4) / h
"<fun>{<v>f</v>(<v>t</v>)} = <p1111><v>p</v>∙{1}</p1111><see> ∙200∙2 / (<v>p</v>²+4) </see>"+
"; <rem> &nbsp; <v>  &nbsp;  p</v> = 1 / ∫</rem>",
//2:p ∙ p∙{1} = p / h
"<fun>{<v>f</v>(<v>t</v>)} = <see><v>p</v></see> ∙ <p1111><v>p</v>∙{1}</p1111></fun>",
//3:{1}
"<fun>{<v>f</v>(<v>t</v>)} = <see>( <v>p / p²</v> )</see> ∙ <p1111><v>p</v>∙{1}</p1111>"
+" = {1}</fun>",
//4:(1/h) / (p²+p+4)
"<fun><v>f</v> = {<v>f</v>(<v>t</v>)} = <p1111><v>p</v>∙{1}</p1111> ∙ 1 / (<v>p</v>²+<v>p</v>+4)"+
"; </fun>",
//5:(1/h) / (p²+p+4) ∙ exp(−To√(p²+1))
"<fun><v>f</v> = (<p1111><v>p</v>∙{1}</p1111> ∙ 1 / (<v>p</v>²+<v>p</v>+4))"+
" ∙ exp(−<see><v>T</v>o</see>√(<v>p</v>²+1)); </fun> &nbsp; ",
//6:(1/h) / (p²+p+4) ∙ exp(−To√(p²+1)−(−To)p)
"<fun><v>f</v> = (<p1111><v>p</v>∙{1}</p1111> ∙ 1 / (<v>p</v>²+<v>p</v>+4))"+
" ∙ exp(−<v>T</v>o√(<v>p</v>²+1)<see>−(−<v>T</v>o)<v>p</v></see>) </fun>",
//7://(1/h) / (p²+p+4) ∙ exp(−To√(p²+1)) ∙ exp(−(−To)p)
"<fun><v>f</v> = (<p1111><v>p</v>∙{1}</p1111> ∙ 1 / (<v>p</v>²+<v>p</v>+4))"+
" ∙ exp(−<v>T</v>o√(<v>p</v>²+1))<see> ∙ exp(−(−<v>T</v>o)<v>p</v>)</see> </fun>",
//8://pⁿ ∙ (1/h) / (p²+p+4)
"<fun><v>f</v> = <see><v>pⁿ</v> ∙ </see> <p1111><v>p</v>∙{1}</p1111> ∙ 1 / (<v>p</v>²+<v>p</v>+4)"+
"; </fun>",
//9://exp(−(−a) p) ∙ (1/h) / (p²+p+4) ∙ exp(−2√(p²+1))
"<fun><v>f</v> = <see>exp(−(−<v>a</v>) <v>p</v>) ∙ </see><p1111><v>p</v>∙{1}</p1111> ∙ (1/(<v>p</v>²+<v>p</v>+4))"+
" ∙ exp(−2 √(<v>p</v>²+1))</fun>",
//font1i
""); 

public static var INF_GR_TYPE_TITLE :Array = new Array( //opis [2*i+lang_Id]
//0: 200*sin(2*t)
"Continuous function restored from samples",
"Odtwarzanie funkcji ciągłej z jej ciągu próbek",
//1: 200 / (p² + 4)  /h
"Processing of samples and approximation",
"Przetwarzanie próbek i odtwarzanie funkcji ciągłej",
//2:  p ∙ p∙{1} = p /h
"High derivative of continuous function",
"Wysoka pochodna funkcji",
//3:  {1}
"<v>p</v>²{1} after double integration",
"<v>p</v>²{1} po dwukrotnym całkowaniu jest f. ciągłą",
//4: (1/h) / (p² + p + 4) * exp(−To √(p² + 1))
"Rational function",
"Funkcja wymierna",
//5: (1/h) / (p² + p + 4) * exp(−To √(p² + 1))
'Function with "negative delay" operator',
'Funkcja z operatorem "ujemnego opóźnienia"',
//6: (1/h) / (p² + p + 4) * exp(−To √(p² + 1)  −(−To) p)
'Neutralization of "negative delay"',
'Neutralizacja "ujemnego opóźnienia"',
//7: // (1/h) / (p² + p + 4) * exp(−To √(p² + 1)) * exp(−(−To) p)
"Neutralization as in previous example, but disadvantageous order of calculation – "
+" see a graph  for <v>N</v> > 100 and <v>h</v> ≤ 0.1",
"Tu też neutralizacja - funkcja jest matematycznie równa poprzedniej - "
+"ale tu jest niekorzystna kolejność obliczeń, "
+"co widać dla <v>N</v> > 100 i <v>h</v> ≤ 0.1",
//8://pⁿ ∙ (1/h) / (p²+p+4)
"Discovering order of integration of DSP black box",
"Odkrywanie rzędu całkowania czarnej skrzynki DSP",
//9://exp(−(−a) p) ∙ (1/h) / (p²+p+4) ∙ exp(−2√(p²+1))
"Discovering delay in DSP black box",
"Odkrywanie opóźnienia w algorytmie czarnej skrzynki DSP",
//
"");

public static var HDR_GR_TYPE_ADDINF :Array = new Array( //html
//0:200sin(2t)
"<big><where><fun><v><u>f</u></v> = 200 ∙ </fun></where></big>"
+"<big2><where><fun> (˜sin(<see>0</see>)˜, sin(2∙<see>1<v>h</v></see>)˜sin(2∙<see>2<v>h</v></see>)˜...˜) </fun></where></big2>",
//1:200  / (p²+4) / h
"<big><br><fun><v><u>f</u></v> = <p1111><v><u>p</u></v>∙(˜0.5˜, 1˜1˜1˜1˜ ...˜)</p1111>"
+"<see> ∙ <v>F</v>(<v><u>p</u></v>)</see></fun></big>"
+"<big2><fun><rem><v><u>p</u></v> = (2/<v>h</v>)∙(˜1˜, -1˜) / (˜1˜, 1˜)</rem> </fun></big2>",
//2:p ∙ p∙{1} = p / h
"",
//3:{1}
"",
//4:(1/h) / (p²+p+4) ∙ exp(−To√(p²+1))
"",
//5:(1/h) / (p²+p+4) ∙ exp(−To√(p²+1))
"",
//6:(1/h) / (p²+p+4) ∙ exp(−To√(p²+1)−(−To)p)
"",
//7://(1/h) / (p²+p+4) ∙ exp(−To√(p²+1)) ∙ exp(−(−To)p)
"",
//8://pⁿ ∙ (1/h) / (p²+p+4)
"",
//9://exp(−(−a) p) ∙ (1/h) / (p²+p+4) ∙ exp(−2√(p²+1))
"",
//
""); 



public var defTo :Number = -0.1;

public function refreshHeader(Void):Void{
	graphPoly.grphType = Math.abs(graphPoly.grphType+graphPoly.GRPH_TYPE_NUM)
		% graphPoly.GRPH_TYPE_NUM;
	var s :String = 
		graphPoly.HDR_GR_TYPE_STR[graphPoly.grphType]
		+((graphPoly.grphType >= 5 && graphPoly.grphType <= 5) 
			? "<see> <v>T</v>o = "+defTo+"</see>" :"")

	this.mcBckgrnd.tfHeader.htmlText =
		"<p><num> "+(graphPoly.grphType-0)+". </num>"
		+s +"</p>";
	this.mcBckgrnd.tfInfo.htmlText =  
		"<bighead>"+INF_GR_TYPE_TITLE[
			graphPoly.grphType*graph0.LANG_NUM+graph0.lang_Id]+"</bighead> "
		
		+"<big>"+s +"<br> </big>"

		+HDR_GR_TYPE_ADDINF[graphPoly.grphType];

	this.mcBckgrnd.tfInfo._alpha = 100;
	/* 
	this.mcInfo = this.mcTarget.attachMovie(
		"png"+graphPoly.grphType, "png"+graphPoly.grphType, this.nDepthInfo); 
	this.mcInfo._x = this.nX1+5;// (Stage.width - this.picture._width)/2;
	this.mcInfo._y = this.nY1+5;
	*/		
	
	switch ( graphPoly.grphType ) {
	case 3 : 
		this.mcBckgrnd.tfY_min.text = graphPoly.nY_min = -3;
		this.mcBckgrnd.tfY_max.text = graphPoly.nY_max = 3;
		break;

	case 4: // (1/h) / (p²+p+4)
	case 5: // (1/h) / (p²+p+4) ∙ exp(-To √(p²+1))
	case 6: // (1/h) / (p²+p+4) ∙ exp(-To √(p²+1)  -(-To)p)
	case 7: // (1/h) / (p²+p+4) ∙ exp(-To √(p²+1)) ∙ exp(-(-To)p)
	case 9: // exp(−(−a) p) ∙ (1/h) / (p²+p+4) ∙ exp(−2√(p²+1))
		this.mcBckgrnd.tfY_min.text = graphPoly.nY_min = -0.9;
		this.mcBckgrnd.tfY_max.text = graphPoly.nY_max = 0.9;
		break;

	case 8: // pⁿ ∙ (1/h) / (p²+p+4) 
		this.mcBckgrnd.tfY_min.text = graphPoly.nY_min = -1.5;
		this.mcBckgrnd.tfY_max.text = graphPoly.nY_max = 1.5;
		break;
		
	default : 
		this.mcBckgrnd.tfY_min.text = graphPoly.nY_min = -300;
		this.mcBckgrnd.tfY_max.text = graphPoly.nY_max = 300;
		break;
		
	}
}//public function refreshHeader	


function graphPoly( target :MovieClip, depth :Number ){
	super(target, depth);

	if ( this.nDepth < 0 ) this.nDepthPoly = -this.nDepth;
	else this.nDepthPoly = this.mcBckgrnd.getNextHighestDepth();
	this.nDepthInfo = 		this.nDepthPoly++;
	this.nDepthPolyLim = 	this.nDepthPoly++;
	this.nDepthPoly0 = 		this.nDepthPoly++;

	mcPolyLim =this.mcTarget.createEmptyMovieClip(
		"mcPolyLim"+this.nDepthPolyLim, this.nDepthPolyLim);

	mcPoly0 =this.mcTarget.createEmptyMovieClip(
		"mcPoly"+(this.nDepthPoly0), this.nDepthPoly0);

	mcPoly =this.mcTarget.createEmptyMovieClip(
		"mcPoly"+this.nDepthPoly, this.nDepthPoly);
	//trace("nDepthPoly= " + this.nDepthPoly+" nDepthLineX= "+this.nDepthLineX+" nDepthLineY= "+this.nDepthLineY, Log.INFO);

}//constructor


public function drawBackground():Void{
	super.drawBackground();

	this.mcBckgrnd.tfX_label.textColor=0;
	this.mcBckgrnd.tfY_label.textColor=0;

	this.mcBckgrnd.tfX_label.text = "t";
	this.mcBckgrnd.tfY_label.text = "f(t)";

	//trace('robię nagłówek');
	with ( this.mcBckgrnd.tfHeader ) {
		graph0.my_fmt.align = 'left';
		setNewTextFormat(graph0.my_fmt);
		graph0.my_fmt.align = 'center';
	
		html = true;
		selectable = false;
		embedFonts = true;
		//fontFamily = 'font1';
		//_alpha = 20;
	}
	var styles:TextField.StyleSheet = new TextField.StyleSheet();
	//styles.setStyle("body",{fontFamily: 'Arial,Helvetica,sans-serif',fontSize: '14px',color:'#0000FF'});
	styles.setStyle("p",
//		{display:'inline',fontFamily: 'font1',fontSize: '16',color:'#000000', kerning:'false'});
		{display:'inline',fontFamily: 'font1',fontSize: '16',color:'#000000', kerning:'true',letterSpacing:'1'});
	styles.setStyle("big",
		{display:'block',fontFamily: 'font1',fontSize: '32',color:'#000000'});
	styles.setStyle("big2",
		{display:'block',fontFamily: 'font1',fontSize: '28',color:'#000000'});
	styles.setStyle("bighead",
		{display:'block',fontFamily: 'font1',fontSize: '22',color:'#0000AA'});
	styles.setStyle("num",{display:'inline',color:'#0000FF'});
	styles.setStyle("fun",{display:'inline'});
	styles.setStyle("v",{display:'inline',fontFamily: 'font1i',fontStyle:'italic'});
	styles.setStyle("see",{display:'inline',color:'#FF00FF'});
	styles.setStyle("rem",{display:'inline',color:'#aaaaaa'});
	styles.setStyle("p1111",{display:'inline',color:'#993300'});
	styles.setStyle("where",
		{display:'inline',color:'#0000FF'});

	this.mcBckgrnd.tfHeader.styleSheet = styles;
/////////////////////////////	
	this.mcBckgrnd.createTextField( "tfInfo", this.nDepthInfo,
		this.nX1+HEADER_MARG_LR, 
		this.nY1+HEADER_MARG_LR+5, 
		(this.nXw-HEADER_MARG_LR),//width
		(this.nYh-HEADER_MARG_LR));
	with ( this.mcBckgrnd.tfInfo ) {
		multiline = true;
		wordWrap = true;
		html = true;
		selectable = false;
		embedFonts = true;
		styleSheet = styles;
	}
	
	this.refreshHeader();

//śledzenie wartości tf._m.. w n._m..
	this.mcBckgrnd.tfX_min.text = graphPoly.nX_min;
	this.mcBckgrnd.tfX_max.text = graphPoly.nX_max;
	this.mcBckgrnd.tfY_min.text = graphPoly.nY_min;
	this.mcBckgrnd.tfY_max.text = graphPoly.nY_max;
	
	this.mcBckgrnd.tfX_min.onChanged = 
		function(tf_:TextField) {
			graphPoly.nX_min = parseFloat(tf_.text); graphPoly.bPolyLimDrawn = false;};		
	this.mcBckgrnd.tfX_max.onChanged = 
		function(tf_:TextField) {
			graphPoly.nX_max = parseFloat(tf_.text); graphPoly.bPolyLimDrawn = false;};		
	this.mcBckgrnd.tfY_min.onChanged = 
		function(tf_:TextField) {
			graphPoly.nY_min = parseFloat(tf_.text); graphPoly.bPolyLimDrawn = false;};		
	this.mcBckgrnd.tfY_max.onChanged = 
		function(tf_:TextField) {
			graphPoly.nY_max = parseFloat(tf_.text); graphPoly.bPolyLimDrawn = false;};		
			
}//public function drawBackground

public function clrPolyLim (Void):Void {
	graphPoly.bPolyLimDrawn = false;
	mcPolyLim =this.mcTarget.createEmptyMovieClip(
		"mcPolyLim"+this.nDepthPolyLim, this.nDepthPolyLim);
}

public function redraw (xVal :Number, yVal :Number, shot :Boolean) {
	var tmpPoly :MovieClip = null;
	var nPolyCl :Number = 0;
	var nPolyPtCl :Number = 0;
	var nPtSz :Number = 4;
	var nLnSz :Number = 1;
	var i :Number;
	var bPolyLim5 :Boolean = false;//specjalnie spreparowane "idealne" rozwiązanie
	var bPolyLim7 :Boolean = false;//specjalnie spreparowane "idealne" rozwiązanie

	var To :Number = defTo;
	var h :Number = 0.3;
	
	var a_rank :Number = -To;

	//if ( this.mcInfo._alpha > 8 )	this.mcInfo._alpha -= 2;
	if ( this.mcBckgrnd.tfInfo._alpha > graphPoly.alphaInf )
		this.mcBckgrnd.tfInfo._alpha -= 1;//2;
	//else this.mcBckgrnd.tfInfo._alpha = 0;

	if ( ! graphPoly.bPolyLimDrawn ) {//small h by big pN.max_N
		pN.max_N = 128;
		if ( graphPoly.grphType == 5 ) {//(1/h) / (p² + p + 4) * exp(-To √(p² + 1))
			bPolyLim5 = true;
			//pN.max_N = 64;
		}
		if ( graphPoly.grphType == 7 ) {
			bPolyLim7 = true;
			//pN.max_N = 64;
		}
		switch ( graphPoly.grphType ) {
		case 9://  - na razie pomijam sprawę linii granicznej - ale da sie zrobić...
		case 8:// 
		case 2://  p ∙ p∙{1} = p /h
			graphPoly.bPolyLimDrawn = true;//nie da się narysować
			break;
			
		case 6:// (1/h) / (p² + p + 4) * exp(-To √(p² + 1)  -(-To) p)
			;//pN.max_N = 64;

		default :
			h = ( graphPoly.nX_max - graphPoly.nX_min ) / pN.max_N;
			mcPolyLim =this.mcTarget.createEmptyMovieClip(
				"mcPolyLim"+this.nDepthPolyLim, this.nDepthPolyLim);
		}
	}
	if ( ! graphPoly.bPolyLimDrawn ) {
		//trace("nDepthPolyLim= " + this.nDepthPolyLim+" N= "+pN.max_N, Log.INFO);
		graphPoly.bPolyLimDrawn = true; 
		tmpPoly = mcPolyLim;
		nPolyCl = nPolyColorLim;
		nPolyPtCl = nPolyPtColorLim;
		nLnSz = nLnSizeLim;
		nPtSz = nPtSizeLim;
	}
	else {				//animowane cyfry PN
		h = xVal;

		if ( graphPoly.grphType == 8 ) {
		//8://pⁿ ∙ (1/h) / (p²+p+4)
			pN.max_N = 128;

			//a_rank = yVal/10; //Math.round(yVal/10); 
			//a_rank = Math.round(yVal)/10; 
			a_rank = yVal;
		}
		else if ( graphPoly.grphType == 9 ) {
		//9://exp(−(−a) p) ∙ (1/h) / (p²+p+4) ∙ exp(−2√(p²+1))
			pN.max_N = 64;
			To = 2;

			//a_rank = yVal/10; //Math.round(yVal/10); 
			//a_rank = -Math.round(yVal*10)/100; 
			a_rank = -yVal;
		}
		else	
			pN.max_N = Math.round(yVal); 

		if ( shot )
			mcPoly0 =this.mcTarget.createEmptyMovieClip(
				"mcPoly"+(this.nDepthPoly0), this.nDepthPoly0);
		mcPoly =this.mcTarget.createEmptyMovieClip(
			"mcPoly"+this.nDepthPoly, this.nDepthPoly);

		if ( shot ) {
			tmpPoly = mcPoly0;
			nPolyCl = nPolyColor0;
			nPolyPtCl = nPolyPtColor0;
			nLnSz = nLnSize0;
			nPtSz = nPtSize0;
		}
		else {
			tmpPoly = mcPoly;
			nPolyCl = nPolyColor;
			nPolyPtCl = nPolyPtColor;
			nLnSz = nLnSize;
			nPtSz = nPtSize;
		}
		if ( isNaN( xVal ) || isNaN( yVal ) ) return;
	}

	//if ( shot ) {pN.TRACE_DIGITS_on = true; pN.TRACE_OPER_on = true;}
	
/*
	var p_05111 :pN = 
		new pN("p_05111", pN.PN2_MUL, 1, 
			new pN("", pN.CONST_P_TRAP, 1/h),
			new pN("", pN.CONST_05111, 1)
		);
		
	var a :pN = 
		new pN("a", pN.PN2_MUL, 1, 
			new pN("", pN.CONST_P_TRAP, 1/h),
			p_05111
		);
*/	//zbędne: var p_05111 :pN = //po prostu 1/h przy pN.CONST_P_TRAP
	
	var a :pN;

	switch ( graphPoly.grphType ) {
		
	case 1: //200  2 / (p² + 4)  /h
		a =
		new pN("a", pN.PN2_DIV, 1,
			new pN("", pN.CONST_1, 200*2/h),
			new pN("", pN.PN2_ADD, 1, 
				new pN("", pN.CONST_P_TRAP_PWR_2, 1/h),
				new pN("", pN.CONST_1, 4)
			)
		);
		//trace(a.mant, Log.INFO);
		break;

	case 2: //p ∙ p∙{1} = p /h
		a  = 
			new pN("a", pN.CONST_P_TRAP, 1/h * (1/h)); /* (1/h)=p_05111 */
		break;

	case 3: //1: {1}
		a  = new pN("a", pN.CONST_05111, 1);
		break;
		
	case 4: // (1/h) / (p² + p + 4) 		
		a =
		new pN("a", pN.PN2_DIV, 1,
			new pN("", pN.CONST_1, 1/h),
			new pN("", pN.PN2_ADD, 1, 
				new pN("", pN.CONST_P_TRAP_PWR_2, 1/h),
				new pN("", pN.PN2_ADD, 1, 
					new pN("", pN.CONST_P_TRAP, 1/h),
					new pN("", pN.CONST_1, 4)
				) 
			)
		);
		break;
	case 8: // pⁿ ∙ (1/h) / (p²+p+4) 		
		a =
		new pN("a", pN.PN2_DIV, 1/h,

			new pN("", pN.PN1_PWR, a_rank, 
				new pN("", pN.CONST_P_TRAP, 1/h)
			),
			new pN("", pN.PN2_ADD, 1, 
				new pN("", pN.CONST_P_TRAP_PWR_2, 1/h),
				new pN("", pN.PN2_ADD, 1, 
					new pN("", pN.CONST_P_TRAP, 1/h),
					new pN("", pN.CONST_1, 4)
				) 
			)
		);
		break;

	case 5: // (1/h) / (p² + p + 4) ∙ exp(-To √(p² + 1))		
	case 6: // (1/h) / (p² + p + 4) ∙ exp(-To √(p² + 1)  -(-To) p)
	case 7: // (1/h) / (p² + p + 4) ∙ exp(-To √(p² + 1)) ∙ exp(-(-To) p)
	case 9: // exp(−(−a) p) ∙ (1/h) / (p²+p+4) ∙ exp(−2√(p²+1))
		var expTo :pN; //exp(...)

		if (To == 0) 	expTo = new pN("expTo", pN.CONST_1, 1 )
		else {
			if ( ( bPolyLim5 ) || ( graphPoly.grphType == 6 ) || ( bPolyLim7 ) ) {
				expTo = 
				new pN("expTo", pN.PN1_EXP, 1,
					new pN("", pN.PN2_ADD, 1, 
						new pN("", pN.PN1_MUL, -To,
							new pN("", pN.PN1_PWR, 0.5,
								new pN("", pN.PN2_ADD, 1, 
									new pN("", pN.CONST_P_TRAP_PWR_2, 1/h),
									new pN("", pN.CONST_1, 1)
								)
							)
						),
						new pN("", pN.CONST_P_TRAP, -(-To)/h)
					)
				);
			}

			else if ( ( graphPoly.grphType == 7 )||( graphPoly.grphType == 9 )) {
				expTo = 
				new pN("expTo", pN.PN2_MUL, 1,
					new pN("", pN.PN1_EXP, 1,
						new pN("", pN.PN1_MUL, -To,
							new pN("", pN.PN1_PWR, 0.5,
								new pN("", pN.PN2_ADD, 1, 
									new pN("", pN.CONST_P_TRAP_PWR_2, 1/h),
									new pN("", pN.CONST_1, 1)
								)
							)
						)
					),
					new pN("", pN.PN1_EXP, 1,
						new pN("", pN.CONST_P_TRAP, -( /* -To */ a_rank)/h)
					)
				);
			}
			
			else {// graphPoly.grphType == 5
				expTo = 
				new pN("expTo", pN.PN1_EXP, 1,
					new pN("", pN.PN1_MUL, -To,
						new pN("", pN.PN1_PWR, 0.5,
							new pN("", pN.PN2_ADD, 1, 
								new pN("", pN.CONST_P_TRAP_PWR_2, 1/h),
								new pN("", pN.CONST_1, 1)
							)
						)
					)
				);
			}
		}
		
		a =
		new pN("", pN.PN2_MUL, 1, 

			expTo,

			new pN("", pN.PN2_DIV, 1,
				new pN("", pN.CONST_1, 1/h),
				new pN("", pN.PN2_ADD, 1, 
					new pN("", pN.CONST_P_TRAP_PWR_2, 1/h),
					new pN("", pN.PN2_ADD, 1, 
						new pN("", pN.CONST_P_TRAP, 1/h),
						new pN("", pN.CONST_1, 4)
					) 
				)
			)

		);
		
		delete expTo;
		break;
///////end 5, 6: (1/h) / (p² + p + 4) ∙ exp(-To √(p² + 1)  -(-To) p)
////// end 7: // (1/h) / (p² + p + 4) ∙ exp(-To √(p² + 1)) ∙ exp(-(-To) p)

	default : //0: 200∙sin(2∙t)
		a = new pN("a", pN.CONST_1, 1);
		for ( i = 0; i < pN.max_N; ++i) 
			a.mant[i] = 200*Math.sin(2* h*i);
		break;
	}	
	
	if ( shot ) {pN.TRACE_DIGITS_on = false; pN.TRACE_OPER_on = false;}

	var x :Number
	var y :Number 

	var dx :Number = h * this.nXw /( graphPoly.nX_max - graphPoly.nX_min);
	
	var y_unit:Number = this.nYh / ( graphPoly.nY_max - graphPoly.nY_min);
	var y0 :Number = this.nY1+this.nYh + graphPoly.nY_min * y_unit;

	x = this.nX1 -
		graphPoly.nX_min * this.nXw / ( graphPoly.nX_max - graphPoly.nX_min);
	i = 0;
	while ( ( x < this.nX1 - dx / 2) && ( i < pN.max_N ) ) {
		++i;
		x += dx;
	}
	if ( bPolyLim5 ) x -=  (-To) * this.nXw / ( graphPoly.nX_max - graphPoly.nX_min);

	if  ( i < pN.max_N ) with ( tmpPoly ) {
		y = this.nY1+this.nYh - ( a.mant[i] - graphPoly.nY_min ) * y_unit;
		moveTo( x, y );
		for ( ; ++i;) {
			lineStyle( nPtSz , nPolyPtCl);
			lineTo( x+0.3, y );
			if ( i >= pN.max_N ) break;
			lineStyle( nLnSz , nPolyCl);
			x += dx; 
			if ( x > this.nX1+this.nXw ) break;
			//y = this.nY2 - ( a.mant[i] - graphPoly.nY_min ) * y_unit;
			y = y0 - a.mant[i] * y_unit;
			lineTo( x, y );
		}
	}
	
	//delete p_05111;
	delete a;	
}	
	
}